﻿Imports System.Drawing.Imaging
Imports System.Drawing


Public Class frmSlam

    Public Sub mnuOpenMapSLAMMap_Click(sender As System.Object, e As System.EventArgs) Handles mnuOpenMapSLAMMap.Click
        OpenFD.Title = "Open a New Map"
        OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then
            GotABotClass.subOpenMap(OpenFD.FileName)
            bmpSlamMap.Dispose()
            bmpSlamMap = New Bitmap(System.Drawing.Image.FromFile(OpenFD.FileName), GotABotClass.myMap.Image.Width, GotABotClass.myMap.Image.Height)
            subLoadSlamMapArray()
            'Dim tmcTemp As typeMapCoordinate = ftnFindNearestUnexploredLocation()
            'subDrawDestination(tmcTemp)
            '            ftnFindSlamPath()
        End If
    End Sub

    Private Sub mnuSaveSLAMMap_Click(sender As System.Object, e As System.EventArgs) Handles mnuSaveSLAMMap.Click
        Dim saveFD As New SaveFileDialog()
        saveFD.Title = "Save a copy of the map"
        saveFD.Filter = "BitMap Files(*.bmp)|*.bmp"
        If mnuMapRaw.Checked Then
            saveFD.FileName = "SLAM_Map_Raw"
        ElseIf mnuMapSmooth.Checked Then
            saveFD.FileName = "SLAM_Map_Smooth"
        ElseIf mnuMapThreshold.Checked Then
            saveFD.FileName = "SLAM_Map_Threshold"
        ElseIf mnuMapEdge.Checked Then
            saveFD.FileName = "SLAM_Map_Edge"
        Else
            saveFD.FileName = "SLAM_Map"
        End If
        Dim DidWork As Integer = saveFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
        bmpSlamMap.Save(saveFD.FileName, ImageFormat.Bmp)
    End Sub

    Private Sub mnuExitSLAM_Click(sender As System.Object, e As System.EventArgs) Handles mnuExitSLAM.Click
        Me.Close()
    End Sub

    Private Sub mnuMapRaw_Click(sender As System.Object, e As System.EventArgs) Handles mnuMapRaw.Click
        mnuMapRaw.Checked = True
        mnuMapThreshold.Checked = False
        mnuMapSmooth.Checked = False
        mnuMapEdge.Checked = False
        subDisplaySlamMap()
    End Sub

    Private Sub mnuMapThreshold_Click(sender As System.Object, e As System.EventArgs) Handles mnuMapThreshold.Click
        mnuMapRaw.Checked = False
        mnuMapThreshold.Checked = True
        mnuMapSmooth.Checked = False
        mnuMapEdge.Checked = False
        subDisplaySlamMap()
    End Sub

    Private Sub mnuMapSmooth_Click(sender As System.Object, e As System.EventArgs) Handles mnuMapSmooth.Click
        mnuMapRaw.Checked = False
        mnuMapThreshold.Checked = False
        mnuMapSmooth.Checked = True
        mnuMapEdge.Checked = False
        subDisplaySlamMap()
    End Sub

    Private Sub mnuMapEdge_Click(sender As System.Object, e As System.EventArgs) Handles mnuMapEdge.Click
        mnuMapRaw.Checked = False
        mnuMapThreshold.Checked = False
        mnuMapSmooth.Checked = False
        mnuMapEdge.Checked = True
        subDisplaySlamMap()
    End Sub

    Private Sub butMakeMap_Click(sender As System.Object, e As System.EventArgs) Handles butMakeMap.Click
        boolStop = False
        boolSlam = True
        modSLAM.subSlamTop(sender, e)
        Me.Refresh()
    End Sub

    Private Sub butOK_Click(sender As System.Object, e As System.EventArgs) Handles butOK.Click
        Me.Close()
    End Sub

    Private Sub radioWaitForScan_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles radioWaitForScan.Click
        updnTime.Visible = Me.radioWaitForScan.Checked
        lblWaitTime.Visible = Me.radioWaitForScan.Checked
        radioNoDelay.Visible = Me.radioWaitForScan.Checked
    End Sub

    Private Sub radioNoDelay_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles radioNoDelay.CheckedChanged
        updnTime.Visible = Me.radioWaitForScan.Checked
        lblWaitTime.Visible = Me.radioWaitForScan.Checked
        radioNoDelay.Visible = Me.radioWaitForScan.Checked
    End Sub

    Private Sub frmSlam_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Private Sub chkShowBuffer_CheckedChanged(sender As Object, e As EventArgs) Handles chkShowBuffer.CheckedChanged
        'If boolSlam Then
        If chkShowBuffer.Checked Then
            subThresholdSlamRawMapArrayToMapArray()
            subAddBufferSpace()
            For intX As Integer = 0 To Map_SizeX - 1      '  Add a buffer space around all walls and objects so that the robot won't bang into them
                For intY As Integer = 0 To Map_SizeY - 1
                    If (byteNavigationMap(intX, intY) > 0) And (byteNavigationMap(intX, intY) <= constMaxBufferSpaceCost) Then _
                        bmpSlamMap.SetPixel(intX, intY, Color.Red)
                    '              subDrawMapPixel(intX, intY, Color.Red)
                Next intY
            Next intX
            GotABotClass.subRedraw(tbpBotPose)
        End If
    End Sub
End Class