﻿
Imports System.Math

' RoboReal Fiducial and AVM recognition

Module modLocalizeRR


    Public Sub GetFiducials(ByRef tirFiducials() As typeImageRecognized)
        On Error Resume Next
        Dim sngSizeFactor As Single = 1
        Dim strFiducials As String = ftnGetVariableFromRR("FIDUCIALS")
        Dim strNames As String = ftnGetVariableFromRR("FIDUCIALS_PATH")
        Dim strParsedFiducials As String() = strFiducials.Split(",")
        Dim intStart, intLength As Integer
        tirFiducials(0).Name = ""
        If strParsedFiducials.Length > 0 Then
            For inti As Integer = 0 To (strParsedFiducials.Length / 17 - 1)
                subDoEventsIfMainThread()
                intStart = strParsedFiducials(inti * 17 + 15)
                intLength = strParsedFiducials(inti * 17 + 16)
                If (intStart > 0) And (intLength > 0) Then
                    tirFiducials(inti).Name = Mid(strNames, intStart, intLength)
                    tirFiducials(inti).Name = tirFiducials(inti).Name.Replace("\", "")
                    tirFiducials(inti).Name = tirFiducials(inti).Name.Replace(".gif", "")
                    tirFiducials(inti).Name = tirFiducials(inti).Name.Replace("gif", "")
                    tirFiducials(inti).intPixelX = (CShort(strParsedFiducials(inti * 17 + 1)) + CShort(strParsedFiducials(inti * 17 + 3)) _
                                                  + CShort(strParsedFiducials(inti * 17 + 5)) + CShort(strParsedFiducials(inti * 17 + 7))) / 4
                    tirFiducials(inti).Range = 2442 / CShort(strParsedFiducials(inti * 17 + 11)) * 42 / sngCameraFOV
                    tirFiducials(inti).sngYRotation = (strParsedFiducials(inti * 17 + 13))
                    tirFiducials(inti + 1).Name = ""
                    subDoEventsIfMainThread()
                End If
            Next
        End If
    End Sub




    Public Function ftnGetAVMResponse() As String  ' must be thread safe
        ' IF the AVM image recognition application detects an object then it will report it in the form
        ' object  "object name"   FeaturesMatched   TotalFeatures   PixelX   PixelY   Distance(cm)
        '   0               1                2           3             4        5         6        

        On Error Resume Next
        Dim sngSizeFactor As Single = 1
        Dim intObjectsTotal As Integer = Val(ftnGetVariableFromRR("NV_OBJECTS_TOTAL"))
        ftnGetAVMResponse = ""
        If (intObjectsTotal > 0) Then
            Dim sngRange As Single
            Dim strIndex As String = ftnGetVariableFromRR("NV_ARR_OBJ_IDX")
            Dim strParsedIndex As String() = strIndex.Split(",")
            Dim strRectX As String = ftnGetVariableFromRR("NV_ARR_OBJ_RECT_X")
            Dim strParsedRectX As String() = strRectX.Split(",")
            Dim strRectW As String = ftnGetVariableFromRR("NV_ARR_OBJ_RECT_W")
            Dim strParsedRectW As String() = strRectW.Split(",")
            Dim strRectH As String = ftnGetVariableFromRR("NV_ARR_OBJ_RECT_H")
            Dim strParsedRectH As String() = strRectH.Split(",")

            For i As Integer = 0 To intObjectsTotal - 1
                ftnGetAVMResponse += "object " & """" & "AVM_" & strParsedIndex(i) & """" & " 10 30 "
                ftnGetAVMResponse += (CShort(strParsedRectX(i)) + Val(strParsedRectW(i)) / 2).ToString & " 100 "
                sngRange = (intRangeCorrectionFactor(Val(strParsedIndex(i)))) / (Val(strParsedRectW(i)) + Val(strParsedRectH(i)))
                sngRange = sngRange * 1000 / sngCameraFOV
                ftnGetAVMResponse += sngRange.ToString & vbCrLf
            Next i
        End If
    End Function





End Module
